<template>
  <div class="discussion_container">
    <a-tabs :activeKey="discussTab" @change="changeTab">
      <a-tab-pane key="1" tab="问题反馈"></a-tab-pane>
      <a-tab-pane key="2" tab="学术交流"></a-tab-pane>
      <a-tab-pane key="3" tab="聊天灌水"></a-tab-pane>
    </a-tabs>
    <div class="discussion_content">
      <div class="discussion_tools">
        <a-button type="primary" @click="openCreate">创建帖子</a-button>
      </div>
      <div class="post_list">
        <a-empty v-if="dataLoaded && postList.length === 0" :image="simpleImage" />
        <a-card hoverable v-for="(post, index) in postList" :key="index" @click="showDetail(post)">
          <div class="post_head">
            <div class="post_title">{{ post.headline }}</div>
            <div class="post_btn">
              <a-button v-if="user_info.user_type == 'admin'" type="primary" size="small" shape="round" :ghost="!post.topped" @click.stop="handleTop(post)">{{post.topped ? '取消置顶':'置顶'}}</a-button>
              <a-button v-if="user_info.user_id == post.user_id" type="primary" size="small" shape="round" ghost @click.stop="handleUpdate(post)">更新</a-button>
              <a-button v-if="user_info.user_type == 'admin' || user_info.user_id == post.user_id" type="danger" size="small" shape="round" ghost @click.stop="handleDel(post)">删除</a-button>
            </div>
          </div>
          <div class="post_content">{{ post.content }}</div>
        </a-card>
      </div>
    </div>

    <a-modal :title="formStatus === 'creat' ? '创建帖子' : '更新帖子'"
             v-model="visible"
             :confirm-loading="confirmLoading"
             destroyOnClose
             :afterClose="() => $refs.form.resetFields()"
             @ok="handleOk">
      <a-form-model :model="form"
                    ref="form"
                    :rules="formRules"
                    :label-col="{ span: 4 }"
                    :wrapper-col="{ span: 18 }">
        <a-form-model-item label="标题：" prop="headline">
          <a-input v-model="form.headline" :maxLength="80" allowClear placeholder="请输入标题（限制在80个字以内）" />
        </a-form-model-item>
        <a-form-model-item label="内容：" prop="content">
          <a-textarea v-model="form.content" :maxLength="4000" allowClear :rows="4" placeholder="请输入内容（限制在4000个字以内）" />
        </a-form-model-item>
      </a-form-model>
    </a-modal>
  </div>
</template>

<script>
import { Empty } from 'ant-design-vue';
import {mapState} from "vuex";

export default {
  name: "Discussion",
  data() {
    return {
      //tab页签
      tabs: {
        1: "问题反馈",
        2: "学术交流",
        3: "聊天灌水",
      },
      simpleImage: Empty.PRESENTED_IMAGE_SIMPLE,
      //帖子信息列表
      postList: [],
      //是否显示创建帖子页面
      visible: false,
      //确定按钮 loading
      confirmLoading: false,
      //帖子表单
      form: {
        headline: "",
        content: ""
      },
      formRules: {
        headline: [{required: true, message: '标题不能为空', trigger: 'blur'}],
        content: [{required: true, message: '内容不能为空', trigger: 'blur'}],
      },
      formStatus: 'creat',
      update_post_id: '',
      dataLoaded: false,
    }
  },
  computed: {
    ...mapState('user', ['user_info']),
    ...mapState('discuss', ['discussTab'])
  },
  created() {
    this.getData();
  },
  methods: {
    /*切换标签页*/
    changeTab(key) {
      this.$store.state.discuss.discussTab = key;
      this.getData();
    },
    /*查询帖子列表*/
    async getData() {
      this.dataLoaded = false
      await this.$axios.get(`block/${this.discussTab}`, {
        page_num: 1
      }).then( res =>{
        if (res.code === undefined) {
          this.postList = res
        }
      }).catch(() => {})
      this.dataLoaded = true
    },
    /*打开创建帖子页面*/
    openCreate() {
      this.formStatus = 'creat'
      this.visible = true;
    },
    /*置顶帖子*/
    handleTop(post) {
      this.$axios.post(post.topped ? 'post/top/cancel' : 'post/top', {
        post_id: post.post_id
      }).then( res =>{
        if (res.code == 0) {
          this.getData();
        } else {
          this.$notification.error({message: "操作失败"});
        }
      }).catch(() => {
        this.$notification.error({message: "操作失败"});
      })
    },

    handleUpdate(post) {
      this.formStatus = 'update'
      this.update_post_id = post.post_id
      this.form.headline = post.headline
      this.form.content = post.content
      this.visible = true;
    },

    /*删除帖子*/
    handleDel(post) {
      this.$axios.post('post/delete', {
        post_id: post.post_id
      }).then( res =>{
        if (res.code == 0) {
          this.getData();
        } else {
          this.$notification.error({message: "操作失败"});
        }
      }).catch(() => {
        this.$notification.error({message: "操作失败"});
      })
    },
    /*查看帖子详情*/
    showDetail(post) {
      this.$router.push({ path: "/postDetail", query: { currTab: this.discussTab, tabLabel: this.tabs[this.discussTab], id: post.post_id} });
    },
    /*保存帖子*/
    handleOk() {
      this.$refs.form.validate( async valid => {
        if (valid) {
          this.confirmLoading = true;
          let params = {}
          let url = ''
          if (this.formStatus === 'creat') {
            params = {
              ...this.form,
              block_type: Number(this.discussTab)
            }
            url = 'post/add'
          } else {
            params = {
              ...this.form,
              post_id: this.update_post_id,
              block_type: Number(this.discussTab)
            }
            url = 'post/update'
          }
          await this.$axios.post(url, params).then( res =>{
            if (res.code == 0) {
              this.$notification.success({message: this.formStatus === 'creat' ? "创建成功" : '更新成功'});
              this.visible = false
              this.getData();
            } else {
              this.$notification.error({message: this.formStatus === 'creat' ? "创建失败" : '更新失败'});
            }
          }).catch(() => {
            this.$notification.error({message: this.formStatus === 'creat' ? "创建失败" : '更新失败'});
          })
          this.confirmLoading = false;
        }
      })
    }
  }
};
</script>

<style scoped>
.discussion_container {
  width: 800px;
  margin: 0 auto;
  text-align: left !important;
}
.discussion_tools {
  text-align: right;
}
.discussion_tools > .ant-btn {
  margin: 0 10px;
}
.post_list {
  margin-top: 20px;
}
.post_list > .ant-card {
  border-radius: 5px;
  margin-bottom: 10px;
}
.post_head {
  display: flex;
  justify-content: space-between;
  align-items: center;
}
.post_title {
  font-size: 16px;
  font-weight: bold;
}
.post_btn > .ant-btn {
  margin-right: 10px;
}
.post_content {
  color: #888;
  margin-top: 20px;
}
</style>